/*
 * Copyright (c) 2013 DAKOSY Datenkommunikationssystem AG, Hamburg, Germany. All rights reserved.
 */
package org.richfaces.test.ak;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;

@ManagedBean
@SessionScoped
public class OverviewController implements Serializable{
	
	private static final long serialVersionUID = 544466031058458542L;

	private List<TableItem> tableItems;
	private String[] columnsOrder;
	
	@PostConstruct
	public void postConstruct() {
		System.out.println("start: postConstruct");

		tableItems = new ArrayList<TableItem>();
		tableItems.add(new TableItem("Oliver", "New York", "USA"));
		tableItems.add(new TableItem("Jane", "Washington", "USA"));
		tableItems.add(new TableItem("Fred", "Berlin", "Germany"));
		tableItems.add(new TableItem("Thomas", "London", "England"));
		
		columnsOrder = new String[] {"firstName", "city", "country" };
	}
	
	public void changeColumnsOrderWithAjax() {
		System.out.println("start: changeColumnsOrderWithAjax");
		
		changeColumnsOrder();
	}
	
	public String changeColumnsOrderFullRefresh() {
		System.out.println("start: changeColumnsOrderFullRefresh");
		
		changeColumnsOrder();
		
		return "";
	}

	private void changeColumnsOrder() {
		
		logColumnsOrder("before");

		if (columnsOrder[0].equals("firstName")) {
			columnsOrder = new String[] {"country", "city", "firstName" };
		} else {
			columnsOrder = new String[] {"firstName", "city", "country" };
		}
		
		logColumnsOrder("after");
	}

	private void logColumnsOrder(String logIdent) {
		
		System.out.println("logColumnsOrder " + logIdent);
		
		int idx = 0;
		System.out.println("logColumnsOrder, order is: ");
		for (String column : columnsOrder) {
			System.out.println("column " + (idx++) + ": " + column);
		}
	}

	public List<TableItem> getTableItems() {
		return tableItems;
	}
	
	public void setTableItems(List<TableItem> tableItems) {
		this.tableItems = tableItems;
	}

	public String[] getColumnsOrder() {
		return columnsOrder;
	}

}
